#!/bin/sh
# the next line restarts using wish \
exec prowish83 "$0" "$@"
#exec protclsh83 "$0" "$@"
#------------------------------------------------------------------------------
#	general arror message for tcl or tk
#------------------------------------------------------------------------------
proc itrmsg {txt} {
	global logOK
	if {[catch {winfo exists .}]} {
		# alfanumerikus (tcl) felulet
		puts $txt
		return 0
	} else {
		set logName "itr2dxf.log"
		if {$logOK == 0} {
			if {[catch {set logFile [open $logName "a+"]} errmsg] == 1} {
				tk_dialog .msg Hiba $txt error 0 OK
				set logOK 1
			}
			if {[catch {puts $logFile $txt} errmsg] == 1} {
				tk_dialog .msg Hiba $txt error 0 OK
				set logOK 1
			}
			if {[catch {close $logFile} errmsg] == 1} {
				tk_dialog .msg Hiba $txt error 0 OK
				set logOK 1
			}
		}
		# grafikus (tk) felulet
#		set w .log
#		if {[winfo exists $w]} {
#			raise $w
#		} else {
#			toplevel $w
#			wm title $w "Uzenetek"
#			frame $w.w
#			pack $w.w -side bottom -fill both -expand 1
#
#			text $w.w.t -setgrid 1 -wrap none -relief sunken -font courier \
#				-exportselection yes \
#				-yscrollcommand "$w.w.vs set" -xscrollcommand "$w.w.hs set"
#			scrollbar $w.w.vs -orient vertical -command "$w.w.t yview"
#			scrollbar $w.w.hs -orient horizontal -command "$w.w.t xview"
#			pack $w.w.vs -side right -fill y
#			pack $w.w.hs -side bottom -fill x
#			pack $w.w.t -side top -fill both -expand 1
#			bind $w.w.t <Key-Next> "$w.w.t yview scroll 1 pages"
#			bind $w.w.t <Key-Prior> "$w.w.t yview scroll -1 pages"
#			bind $w.w.t <Key-Down> "$w.w.t yview scroll 1 units"
#			bind $w.w.t <Key-Up> "$w.w.t yview scroll -1 units"
#			focus $w.w.t
#		}
#		catch {.log.w.t insert end "$txt\n"}
#		catch {.log.w.t see end}
#		return 0
	}
}
#------------------------------------------------------------------------------
#
#	ITR ASCII adatcsereformatum konvertalasa dxf fajlla
#	V 1.1 (c) Siki Zoltan GNU GPL licenc
#	ITR 2.5 ASCII DAT rekordok
#		megj.: 1
#		reteg: 2
#		pont :10
#		vonal:20 psz1 y1 x1 psz2 y2 x2 reteg toll z1 z2 kod1 kod2
#       jel  :30
#			  32 ? y x z ? ? szog reteg ? szimbolum_kod
#			  32 y x z szog reteg szimbolum_kod
#       txt  :40 meret y x z reteg toll szoveg
#		zaszl:41
#	ITR 3 ASCII DAT rekordok
#		pont :310 psz y x z kod vizszintes_kh magassagi_kh
#       vonal:320 psz1 y1 x1 z1 kod1 psz2 y2 x2 z2 kod2 reteg toll toll_szin
#		jel  :330 y x irany reteg toll_szin jelkulcs_id
#		txt  :340 y x irany tipus reteg toll_szin beszurasi_pont bold underl athuzott szoveg (sortores = Chr(1))
#		zaszl:341 y x irany tipus reteg toll_szin beszurasi_pont bold underl athuzott meret szelesseg_magassag_arany zaszlo_tipus (1 jobb, 2 bal)
#		meret:342 ????
#		txt  :343 y x szog reteg szoveg
#------------------------------------------------------------------------------
proc itr2dxf {fn} {
	set rad2deg [expr {45.0 / atan(1.0)}]
	set deg2rad [expr {atan(1.0) / 45.0}]
	if {! [file exists $fn]} {
		itrmsg "$fn-t nem talalom"
		return
	}
	if {[catch {set f [open $fn "r"]} msg] == 1} {
		itrmsg $msg
		return
	}
	catch {fconfigure $f -encoding cp852}

	set ofn "[file rootname $fn].dxf"
	if {[catch {set of [open $ofn "w"]} msg] != 0} {
		itrmsg $msg
		close $f
		return
	}
#	catch {fconfigure $of -encoding iso8859-2}
	catch {fconfigure $of -encoding cp1250}

	set line 0				;# line element counter
	set symbol 0			;# symbol element counter
	set text 0				;# text element counter
	# collect info from dat file
	while {! [eof $f]} {
		if {[catch {set buf [gets $f]} msg] != 0} {
			itrmsg $msg
			return
		}
		set origbuf $buf	;# save original buffer for text
		while {[regsub -all "  " $buf " " buf]} { }	;# dupla szokozok kivetele
		set buflist [split [string trim $buf]]
		switch -exact -- [lindex $buflist 0] {
			2 {
				if {[llength $buflist] < 8} {
					itrmsg "Hibs rteg sor: $origbuf"
					continue
				}
				set ind [string last [lindex $buflist 7] $origbuf]
				set name [string range $origbuf $ind end]	;# layer info
				regsub -all "\\." $name "_" name
				regsub -all "\[ :,\(\)\]" $name "_" name
				set layers([lindex $buflist 1]) [lrange $buflist 1 6]
				if {[string compare $name "*"] == 0} {
					lappend layers([lindex $buflist 1]) ""	;# no name given
				} else {
					lappend layers([lindex $buflist 1]) $name
				}
			}
			4 {
				if {[llength $buflist] != 7} {
					itrmsg "Hibs font sor: $origbuf"
					continue
				}
				set fonts([lindex $buflist 1]) [lrange $buflist 2 end]
			}
			310 {
				# itr3 point
				set id "[lindex $buflist 2][lindex $buflist 3]"
				set points($id) [lrange $buflist 1 5]
			}
			10 {
				# itr 2.x point
				if {[llength $buflist] != 6} {
					itrmsg "Hibs pont sor: $origbuf"
					continue
				}
				set id "[lindex $buflist 2][lindex $buflist 3]"
				set points($id) [lrange $buflist 1 end]
			}
			320 {
				# itr 3 line
				set lines($line) [list \
				[lindex $buflist 1] [lindex $buflist 2] [lindex $buflist 3] \
				[lindex $buflist 6] [lindex $buflist 7] [lindex $buflist 8] \
				[expr {[lindex $buflist 11] - 1}] \
				[expr {[lindex $buflist 12] - 1}] \
				[lindex $buflist 4] [lindex $buflist 9] \
				[lindex $buflist 5] [lindex $buflist 10]]
				incr line
				set id "[lindex $buflist 2][lindex $buflist 3]"
				if {! [info exists points($id)]} {
					set points($id) [lrange $buflist 1 5]
				}
				set id "[lindex $buflist 7][lindex $buflist 8]"
				if {! [info exists points($id)]} {
					set points($id) [lrange $buflist 6 10]
				}
			}
			20 { 
				# itr 2.5 line
				if {[llength $buflist] != 13} {
					itrmsg "Hibs vonal sor: $origbuf"
					continue
				}
				set lines($line) [lrange $buflist 1 end]
				incr line
				set id "[lindex $buflist 2][lindex $buflist 3]"
				if {! [info exists points($id)]} {
					set points($id) [list [lindex $buflist 1] \
						[lindex $buflist 2] [lindex $buflist 3] \
						[lindex $buflist 9] [lindex $buflist 11]]
				}
				set id "[lindex $buflist 5][lindex $buflist 6]"
				if {! [info exists points($id)]} {
					set points($id) [list [lindex $buflist 4] \
						[lindex $buflist 5] [lindex $buflist 6] \
						[lindex $buflist 10] [lindex $buflist 12]]
				}
			}
			330 {
				# itr 3 symbol
				set symbols($symbol) [list 0 \
					[lindex $buflist 1] [lindex $buflist 2] \
					0.000 0 0 \
					[expr {[lindex $buflist 3] * $deg2rad}] \
					[expr {[lindex $buflist 4] - 1}] \
					[lindex $buflist 5] [lindex $buflist 6]]
				incr symbol
				set id "[lindex $buflist 1][lindex $buflist 2]"
				if {! [info exists points($id)]} {
					set points($id) [list 0 \
						[lindex $buflist 1] [lindex $buflist 2] 0 0 ]
				}
			}
			32 {
				# itr 2.x symbol
				if {[llength $buflist] != 11} {
					itrmsg "Hibs szimblum sor: $origbuf"
					continue
				}
				set symbols($symbol) [lrange $buflist 1 end]
				incr symbol
				set id "[lindex $buflist 2][lindex $buflist 3]"
				if {! [info exists points($id)]} {
					set points($id) [list [lindex $buflist 1] \
						[lindex $buflist 2] [lindex $buflist 3] \
						[lindex $buflist 4] [lindex $buflist 5]]
				}
			}
			340 {
				# itr 3 normal text
				set texts($text) [list \
					[lindex $buflist 4] \
					[lindex $buflist 1] [lindex $buflist 2] \
					[expr {[lindex $buflist 3] * $deg2rad}] \
					[lindex $buflist 4] \
					[expr {[lindex $buflist 5] - 1}] \
					[string range $origbuf 74 end]]
				incr text
			}
			343 {
				set texts($text) [list 1 \
					[lindex $buflist 1] [lindex $buflist 2] \
					[lindex $buflist 3] \
					[expr {[lindex $buflist 4] - 1}] \
					[expr {[lindex $buflist 4] - 1}] \
					[string range $origbuf 45 end]]
				incr text
			}
			40 {
				# itr 2.x normal text
				if {[llength $buflist] < 8} {
					itrmsg "Hibs szveg sor: $origbuf"
					continue
				}
				set texts($text) [lrange $buflist 1 6]
				lappend texts($text) [string range $origbuf 52 end]
				incr text
			}
			341 {
				# text with leader
				# TBD
			}
			41 -
			42 {
				if {[llength $buflist] < 10} {
					itrmsg "Hibs zszls szveg sor: $origbuf"
					continue
				}
				# text with leader
				set x0 [expr {[lindex $buflist 2] - \
					[lindex $buflist 8] / 100.}]
				set y0 [expr {[lindex $buflist 3] - \
					[lindex $buflist 9] / 100.}]
				set buflist [lreplace $buflist 2 3 $x0 $y0]
			 	set texts($text) [lrange $buflist 1 6]
				lappend texts($text) [string range $origbuf 52 end]
				incr text
				itrmsg "zaszlos felirat, zaszlot kihagytam"
			}
		}
	}
	close $f
	# write dxf
	puts $of "  0\nSECTION\n  2\nTABLES"
	# layers
	puts $of "  0\nTABLE\n2\nLAYER"
	# layer 0
	puts $of "  0\nLAYER\n  2\n0\n 70\n0\n 62\n7\n  6\nCONTINUOUS"
	# layer for point block
	puts $of "  0\nLAYER\n  2\nPONT\n 70\n0\n 62\n7\n  6\nCONTINUOUS"
	foreach l [lsort [array names layers]] {
		set layer "[expr {$l + 1}]_[lindex $layers($l) 6]"
		puts $of "  0\nLAYER\n  2\n$layer"
		puts $of " 70\n0"
		if {[lindex $layers($l) 1] == 0} {
			puts $of " 62\n7"		;# layer color?
		} else {
			puts $of " 62\n[lindex $layers($l) 1]"		;# layer color?
		}
		puts $of "  6\nCONTINUOUS"					;# linestyle
	}

	puts $of "  0\nENDTAB"
	puts $of "  0\nENDSEC"
	# blocks
	set blocks ""
	puts $of "  0\nSECTION\n  2\nBLOCKS"
	puts $of "  0\nBLOCK\n  8\n0\n  2\nPONT\n 70\n2"
	puts $of " 10\n0\n 20\n0\n 30\n0\n  3\nPONT\n  1\n"
	puts $of "  0\nATTDEF\n  8\n0\n 62\n0"
	puts $of " 10\n0\n 20\n-1.4\n 30\n0\n40\n1\n  1\n"
	puts $of "  3\nPontkod\n  2\nKOD\n 70\n0"
	puts $of "  0\nATTDEF\n  8\n0\n 62\n0"
	puts $of " 10\n0\n 20\n0\n 30\n0\n40\n1\n  1\n"
	puts $of "  3\nPontszam\n  2\nPONTSZAM\n 70\n0"
	puts $of "  0\nCIRCLE\n  8\n0\n 62\n0"
	puts $of " 10\n0\n 20\n0\n 30\n0\n40\n0.5"
	puts $of "  0\nENDBLK\n  8\n0"
	lappend blocks "PONT"
#	copy standard blocks
	set last ""
	if {[file exists "blocks.dxf"]} {
		set fb [open "blocks.dxf" r]
		while {! [eof $fb]} {
			set b_buf [gets $fb]
			if {$last == "  2"} {
				if {[lsearch -exact $blocks $b_buf] == -1} {
					lappend blocks $b_buf	;# collect block names
				}
			}
			if {[string length $b_buf]} {	;# skip empty lines
				puts $of $b_buf
			}
			set last $b_buf
		}
	} else {
		itrmsg "blocks.dxf fajlt nem talalom"
	}
	puts $of "  0\nENDSEC"
	# entities
	puts $of "  0\nSECTION\n  2\nENTITIES"
	# points
	foreach p [array names points] {
		# create block
		puts $of "  0\nINSERT\n  8\nPONT\n 66\n1\n  2\nPONT"
		puts $of " 10\n[lindex $points($p) 1]\n 20\n[lindex $points($p) 2]"
		puts $of " 30\n[lindex $points($p) 3]"
		puts $of "  0\nATTRIB\n  8\nPONT"
		puts $of " 10\n[lindex $points($p) 1]"
		puts $of " 20\n[expr {[lindex $points($p) 2] - 1.3}]"
		puts $of " 30\n0"
		puts $of " 40\n1\n  1\n[lindex $points($p) 4]\n  2\nKOD\n 70\n0"
		puts $of "  0\nATTRIB\n  8\nPONT"
		puts $of " 10\n[lindex $points($p) 1]"
		puts $of " 20\n[lindex $points($p) 2]"
		puts $of " 30\n0"
		puts $of " 40\n1\n  1\n[lindex $points($p) 0]\n  2\nPONTSZAM\n 70\n0"
		puts $of "  0\nSEQEND"
		puts $of "  8\nPONT"

# pontszam es kod feliratkent
#		puts $of "  0\nPOINT\n  8\nPONT\n 10\n[lindex $points($p) 1]"
#		puts $of " 20\n[lindex $points($p) 2]\n 30\n[lindex $points($p) 3]"
#		puts $of "  0\nTEXT\n  8\nPONTSZAM\n 10\n[lindex $points($p) 1]"
#		puts $of " 20\n[lindex $points($p) 2]\n 30\n[lindex $points($p) 3]
#		puts $of " 40\n1\n  1\n[lindex $points($p) 0]"
#		puts $of "  0\nTEXT\n  8\nPONTKOD\n 10\n[lindex $points($p) 1]
#		puts $of " 20\n[lindex $points($p) 2]\n 30\n[lindex $points($p) 3]"
#		puts $of " 40\n1\n  1\n[lindex $points($p) 4]"
	}
	# lines
	foreach p [array names lines] {
		set lid [lindex $lines($p) 6]
		# layer name index + name
		if {[info exists layers($lid)]} {
			set layer "[expr {$lid + 1}]_[lindex $layers($lid) 6]"
		} else {
			set layer [expr {$lid + 1}]
		}
		puts $of "  0\nLINE\n  8\n$layer"
		puts $of " 10\n[lindex $lines($p) 1]\n 20\n[lindex $lines($p) 2]"
		puts $of " 11\n[lindex $lines($p) 4]\n 21\n[lindex $lines($p) 5]"
	}
	# symbols
	foreach p [array names symbols] {
		set lid [lindex $symbols($p) 7]
		# layer name index + name
		if {[info exists layers($lid)]} {
			set layer "[expr {$lid + 1}]_[lindex $layers($lid) 6]"
		} else {
			set layer [expr {$lid + 1}]
		}
		set szog [expr {[lindex $symbols($p) 6] * $rad2deg}]
		set blockname "SI-1-[lindex $symbols($p) 9]"
		if {[lsearch -exact $blocks $blockname] == -1} {
			itrmsg "Ismeretlen blokk $blockname -> [lindex $blocks end]"
			set blockname [lindex $blocks end]
		}
		puts $of "  0\nINSERT\n  8\n$layer\n  2\n$blockname"
		puts $of " 10\n[lindex $symbols($p) 1]\n 20\n[lindex $symbols($p) 2]"
		puts $of " 50\n$szog"
	}
	# texts
	foreach p [array names texts] {
		set lid [lindex $texts($p) 4]
		# layer name index + name
		if {[info exists layers($lid)]} {
			set layer "[expr {$lid + 1}]_[lindex $layers($lid) 6]"
		} else {
			set layer [expr {$lid + 1}]
		}
		set szog [expr {[lindex $texts($p) 3] * $rad2deg}]
		if {[info exists fonts([lindex $texts($p) 0])]} {
			set size [expr {[lindex $fonts([lindex $texts($p) 0]) 2] / 10. * 2.}]
		} else {
			set size 1
		}
		puts $of "  0\nTEXT\n  8\n$layer"
		puts $of " 10\n[lindex $texts($p) 1]\n 20\n[lindex $texts($p) 2]"
		puts $of " 40\n$size\n  1\n[lindex $texts($p) 6]\n 50\n$szog"
	}
	puts $of "  0\nENDSEC\n  0\nEOF\n"
	close $of
}

#------------------------------------------------------------------------------
#
#   dxf fajl konvertalasa ITR ASCII adatcsereformatuma
#
#	Adatszerkezetek:
#
#	points - pontok tombje, index x es y koordinata, minden elem lista
#            {pontszam x y z pontkod}
#	symbols- szimbolumok tombje, index egy sorszam, minden elem lista
#            {szimbolum_id x y z szog reteg toll}
#	sym    - pontba beillesztett szimbolumok kodjanak listaja, index mint points
#	lref   - tomb a pontba befuto vonalak listaja, index mint points,
#            minden elem egy lista a vonal indexekkel
#	lines  - vonalak tombje, az index sorszam, minden elem lista
#            {reteg x y z x1 y1 z1 toll}
#	texts  - feliratok tombje, az index sorszam, minden elem lista
#			 {txttype x y szog reteg toll felirat]
#
#------------------------------------------------------------------------------
proc dxf2itr {fn} {
	global points symbols lines

# nem jo mert az alappontoknal eltero felirat meretek vannak!!!!
	set txttypes(0) {1}	;# vizsz alappont 1 vagy 2
	set txttypes(1) {3}	;# mag. alappont 3 vagy 4
	set txttypes(5) {10}	;# telepules
	set txttypes(6) {11}	;# fekves
	set txttypes(10) {15}	;# hrsz
	set txttypes(12) {16}	;# alr_jel
	set txttypes(13) {17}	;# alr_muv_ag
	set txttypes(14) {18}	;# min_oszt
	set txttypes(15) {17}	;# sza_alr
	set txttypes(29) {25}	;# lakoep ??????
	set txttypes(30) {25}	;# gazdep
	set txttypes(31) {26}	;# kozep
	set txttypes(32) {27}	;# templom
	set txttypes(33) {28}	;# uzemiep
	set txttypes(34) {29}	;# hazszam
	set txttypes(35) {31}	;# epulettartozek
	set txttypes(37) {33}	;# toronyep
	set txttypes(42) {36}	;# utcanev
	set txttypes(85) {59}	;# dulonev
	set txttypes(93) {25}	;# rendlen_ep
	set txttypes(101) {13}	;# szelvenyszam
	set txttypes(168) {36}	;# utcanev munkabol
	set txttypes(169) {29}	;# hazszam munkabol
	set txttypes(175) {15}	;# hrsz munkabol
	set txttypes(177) {16}	;# alr_jel munkabol
	set txttypes(178) {17}	;# alr_muv_ag munkabol
	set txttypes(179) {18}	;# min_oszt munkabol
	set txttypes(180) {17}	;# sza_alr munkabol
	set txttypes(182) {25}	;# lakoep ?????? munkabol
	set txttypes(183) {25}	;# gazdep munkabol
	set txttypes(184) {26}	;# kozep munkabol
	set txttypes(185) {27}	;# templom munkabol
	set txttypes(186) {28}	;# uzemiep munkabol
	set txttypes(192) {25}	;# rendlen_ep munkabol

	set deg2rad [expr {atan(1.0) / 45.0}]
	set PI [expr {4.0 * atan(1.0)}]
	set PI2 [expr {$PI / 2.0}]
	set PI32 [expr {$PI + $PI2}]

	if {! [file exists $fn]} {
		itrmsg "$fn fajlt nem talalom"
		return
	}

	# load itr layer parameters
	if {[catch {set f [open "dxf2itr.par" "r"]}] == 0} {
		while {! [eof $f]} {
			set buf [gets $f]
			if {[regexp "^ *2 " $buf]} {
				set buflist [split [string trim $buf]]
				set layers([lindex $buflist 1]) [lrange $buflist 2 end]
			}
		}
	}
	if {[catch {set f [open $fn "r"]} msg] == 1} {
		itrmsg $msg
		return
	}
	catch {fconfigure $f -encoding cp1250}

	# open output file
	set ofn "[file rootname $fn].dat"
	if {[catch {set of [open $ofn "w"]} msg] != 0} {
		itrmsg $msg
		close $f
		return
	}
	catch {fconfigure $of -encoding cp852}

	set src 0
	set code ""
	set mode ""
	# skip header/tables till ENTITIES & read extent
	while {! [eof $f] && \
		($code != 2 || [string toupper $value] != "ENTITIES")} {
		set code [gets $f]
		set value [gets $f]
		incr src 2
	}

	# collect info from dxf file
	set entity "START"
	set subentity ""
	set layer ""	;# itr layer number
	set pcode ""	;# point code 
	set psz ""		;# point number
	set txt ""
	set blk ""	;# name of current block
	set attr ""	;# name of current attribute
	set attrval ""
	set x ""
	set y ""
	set z "0"
	set x1 ""	;# endpoint of line
	set y1 ""
	set z1 "0"
	set angle 0
	set line 0	;# number of items
	set text 0
	set symbol 0
	set xmin 1000000
	set ymin 1000000
	set xmax -1000000
	set ymax -1000000
	while {! [eof $f]} {
		incr src
		set code [string trim [gets $f]]
		incr src
		set value [string trim [gets $f]]
		incr src
		switch -exact $code {
			0 { if {$value == "ATTRIB" || $value == "SEQEND" || \
						$value == "VERTEX"} {
					set subentity [string toupper $value]
					continue
				}
				# save prev. entity
				switch -exact $entity {
					ENDSEC -
					START {
					}
					INSERT {
						if {$blk == "PONT"} {
							# store point
							if {![regexp "^\[0-9\]+$" $pcode]} {
								set pcode 0
								itrmsg "Nem numerikus pontkod $x,$y $pcode"
							}
							if {! [info exists points($x$y)] || [lindex $points($x$y) 4] == -9999} {
								set points($x$y) [list $psz $x $y $z $pcode]
							} else {
								itrmsg "Dupla pont: $x,$y"
							}
						} elseif {[regexp "SI-\[0-9\]-\[0-9\]+" $blk]} {
							# pen from layer info
							if {[info exists layers($layer)]} {
								set pen [lindex $layers($layer) 2]
								set sid [lindex [split $blk "-"] 2]
								set symbols($symbol) \
									[list $sid $x $y $z $angle $layer $pen]
								incr symbol
								# count symbol reference number
								if {[info exists sym($x$y)]} {
									lappend sym($x$y) $sid
								} else {
									set sym($x$y) $sid
								}
								# add point if not used yet pcode = -9999!
								if {! [info exists points($x$y)]} {
									set points($x$y) [list 0 $x $y $z -9999]
								}
							} else {
								itrmsg "Rossz reteg $layer $x,$y SZIMBOLUM $blk"
							}
						} else {
							itrmsg "Ismeretlen szimbolum $blk $x,$y"
						}
					}
					TEXT {
						# text style from layer
						if {[info exists txttypes($layer)]} {
							set txttype $txttypes($layer)
						} else {
							if {[catch {set l1 [expr {$layer + 1}]}]} {
								set l1 $layer
							}
							itrmsg "felirat tipus? $x,$y $txt  reteg: $l1"
							set txttype 63
						}
						# pen from layer info
						if {[info exists layers($layer)]} {
							set pen [lindex $layers($layer) 1]
						} else {
							set pen 1
						}
						set texts($text) \
							[list $txttype $x $y $angle $layer $pen $txt]
						incr text
					}
					LINE {
						# pen from layer info
						if {[info exists layers($layer)]} {
							set pen [lindex $layers($layer) 0]
						} else {
							set pen 1
						}
						set lines($line) [list $layer $x $y $z $x1 $y1 $z1 $pen]
						# add point if not used yet pcode = -9999!
						if {! [info exists points($x$y)]} {
							set points($x$y) [list 0 $x $y $z -9999]
						}
						if {! [info exists points($x1$y1)]} {
							set points($x1$y1) [list 0 $x1 $y1 $z1 -9999]
						}
						# count point reference number and build line list
						if {[info exists lref($x$y)]} {
							lappend lref($x$y) $line
						} else {
							set lref($x$y) $line
						}
						# count point reference number and build line list
						if {[info exists lref($x1$y1)]} {
							lappend lref($x1$y1) $line
						} else {
							set lref($x1$y1) $line
						}
						incr line
					}
					default {
						if {[lsearch -exact {ACDBDICTIONARYWDFLT ACDBPLACEHOLDER DICTIONARY DICTIONARYVAR IMAGEDEF LAYOUT MLINESTYLE RASTERVARIABLES VIEWPORT IMAGE IMAGEDEF_REACTOR SECTION SORTENTSTABLE XRECORD} $entity] == -1} {
							itrmsg "Nem tamogatott elem $entity kimarad a konverziobol"
						}
					}
				}

				set entity [string toupper $value]
				set subentity ""
				set layer ""	;# itr layer number
				set pcode ""	;# point code 
				set psz ""		;# point number
				set txt ""
				set blk ""	;# name of current block
				set attr ""	;# name of current attribute
				set attrval ""
				set x ""
				set y ""
				set z "0"
				set x1 ""	;# endpoint of line
				set y1 ""
				set z1 "0"
				set angle 0
			}
			1 { if {$entity == "TEXT"} {
					set txt [string trim $value]
				} elseif {$entity == "INSERT" && $subentity == "ATTRIB" && \
						$blk == "PONT"} {
					if {$attr == "KOD"} {
						set pcode [string trim $value]
						if {![regexp "^\[0-9\]+$" $pcode]} {
								set pcode 0
								itrmsg "Nem numerikus pontkod $x,$y $pcode"
						}
						set attr ""
						set attrval ""
					} elseif {$attr == "PONTSZAM"} {
						set psz [string trim $value]
						if {![regexp "^\[0-9\]+$" $psz]} {
								set psz 99999
								itrmsg "Nem numerikus pontszam $x,$y $psz"
						}
						set attr ""
						set attrval ""
					} else {
						set attrval [string trim $value]
						set attr ""
					}
				}
			}
			2 { if {$entity == "INSERT"} {
					if {[string length $subentity] == 0} {
						set blk [string trim [string toupper $value]]
					} else { 
						set attr [string toupper $value]
						if {[string length $attrval]} {
							if {$attr == "KOD"} {
								set pcode [string trim $attrval]
							} elseif {$attr == "PONTSZAM"} {
								set psz [string trim $attrval]
								if {![regexp "^\[0-9\]+$" $psz]} {
										set psz 99999
										itrmsg "Nem numerikus pontszam $x,$y $psz"
								}
							}
							set attrval ""
							set attr ""
						}
					}
				}
			}
			8 { if {[string length $subentity] == 0} {
					set lst [split $value "_"]
					set layer [lindex $lst 0]	;# layer number
					catch {incr layer -1}		;# back to 0 base
					if {$layer != "PONT" && ![info exists layers($layer)]} {
						if {[catch {set layer1 [expr {$layer+1}]}]} {
							set layer1 $layer
							set layer 0	;# minden a nulla retegre
						}
						itrmsg "Layer? $layer1"
					}
				}
			}
			10 { if {[string length $subentity] == 0} {
					set x [format "%.2f" $value]
					if {$x > 1000 && $x < $xmin} { set xmin $x }
					if {$x > 1000 && $x > $xmax} { set xmax $x }
				}
			}
			11 { if {[string length $subentity] == 0} {
					set x1 [format "%.2f" $value]
					if {$x1 > 1000 && $x1 < $xmin} { set xmin $x1 }
					if {$x1 > 1000 && $x1 > $xmax} { set xmax $x1 }
				}
			}
			20 { if {[string length $subentity] == 0} {
					set y [format "%.2f" $value]
					if {$y1 > 1000 && $y < $ymin} { set ymin $y }
					if {$y1 > 1000 && $y > $ymax} { set ymax $y }
				}
			}
			21 { if {[string length $subentity] == 0} {
					set y1 [format "%.2f" $value]
					if {$y1 > 1000 && $y1 < $ymin} { set ymin $y1 }
					if {$y1 > 1000 && $y1 > $ymax} { set ymax $y1 }
				}
			}
			30 { if {[string length $subentity] == 0} {
					set z [format "%.2f" $value]
					if {$z < 80 || $z > 1015} { set z 0 }
				}
			}
			31 { if {[string length $subentity] == 0} {
					set z1 [format "%.2f" $value]
					if {$z1 < 80 || $z1 > 1015} { set z1 0 }
				}
			}
			40 { if {[string length $subentity] == 0} {
					# height in 0.1 mm, scale is 2000!
					set txtheight [expr {round($value / 2. * 10.)}]
				}
			}
			50 { if {[string length $subentity] == 0} {
					set angle [expr {$value * $deg2rad}]
				}
			}
		}
	}
	close $f

	catch {unset hrsz}
	# output extent
	if {[info exists xmin] && [info exists ymin] && \
			[info exists xmax] && [info exists ymax]} {
		puts $of "   1 extent"
		puts $of [format " 100 %12.2f %12.2f %12.2f %12.2f" \
			$xmin $ymin $xmax $ymax]
	}
	# output points
	puts $of "   1 Pontok"
# 10 psz x y z kod
	foreach p [array names points] {
		set psz [lindex $points($p) 0]
		set x [lindex $points($p) 1]
		set y [lindex $points($p) 2]
		set pcode [lindex $points($p) 4]
		set retegek ""
		if {[info exists lref($x$y)] && [llength $lref($x$y)]} {
			foreach l $lref($x$y) {
				# eredeti retegszam visszaallitasa
				lappend retegek [expr {[lindex $lines($l) 0] + 1}]
			}
			set retegek [lsort -integer $retegek]
		}
		puts $of [format "  10 %10s %12.3f %12.3f %9.3f %5i" \
			$psz $x $y [lindex $points($p) 3] $pcode]
	}
	# output lines
	puts $of "   1 Vonalak"
# 20 psz1 x1 y1 psz2 x2 y2 reteg toll z1 z2 kod1 kod2
	foreach p [lsort -integer [array names lines]] {
		set layer [lindex $lines($p) 0]
		set pid1 "[lindex $lines($p) 1][lindex $lines($p) 2]"
		set pid2 "[lindex $lines($p) 4][lindex $lines($p) 5]"
		if {[info exists points($pid1)] && [info exists points($pid2)]} {
			puts $of [format \
	"  20 %10s %12.3f %12.3f %10s %12.3f %12.3f %3i %3i %9.3f %9.3f %5i %5i" \
				[lindex $points($pid1) 0] \
				[lindex $lines($p) 1] [lindex $lines($p) 2] \
				[lindex $points($pid2) 0] [lindex $lines($p) 4] \
				[lindex $lines($p) 5] \
				$layer [lindex $lines($p) 7] \
				[lindex $lines($p) 3] [lindex $lines($p) 6] \
				[lindex $points($pid1) 4] [lindex $points($pid2) 4]]
		}
	}
	# output symbols
	puts $of "   1 Jelkulcsok"
# 32 psz x y z kod 0? szog reteg? toll? szimbolum
	foreach p [lsort -integer [array names symbols]] {
		set layer [lindex $symbols($p) 5]
		set pid "[lindex $symbols($p) 1][lindex $symbols($p) 2]"
		if {[info exists points($pid)]} {
			puts $of [format \
				"  32 %10s %12.3f %12.3f %10.3f %5i %3i %8.4f %3i %3i %3i" \
				[lindex $points($pid) 0] \
				[lindex $symbols($p) 1] [lindex $symbols($p) 2] \
				[lindex $symbols($p) 3] \
				[lindex $points($pid) 4] 0 [lindex $symbols($p) 4] \
				$layer [lindex $symbols($p) 6] \
				[lindex $symbols($p) 0]]
		}
	}
	# output texts
	puts $of "   1 Feliratok"
# 40 tipus x y szog reteg toll felirat
	foreach p [lsort -integer [array names texts]] {
		set layer [lindex $texts($p) 4]
		puts $of [format "  40 %3i %12.3f %12.3f %8.3f %3i %3i %s" \
			[lindex $texts($p) 0] [lindex $texts($p) 1] [lindex $texts($p) 2] \
			[lindex $texts($p) 3] \
			$layer [lindex $texts($p) 5] [lindex $texts($p) 6]]
	}
	close $of
}

proc conv {} {
global fileTypes
	set fn [string trim \
		[tk_getOpenFile -filetypes $fileTypes -title "ITR ASCII DAT <--> AutoCAD DXF" -defaultextension "dat"]]
	if {[string length $fn]} {
		if {[file exists $fn]} {
			if {[regexp "\.\[dD\]\[aA\]\[tT\]$" $fn]} {
				itr2dxf $fn
			} elseif {[regexp "\.\[dD\]\[xX\]\[fF\]$" $fn]} {
				dxf2itr $fn
			}
		} else {
			if {[itrmsg "Nem tallom a fjlt $fn"] == 0} { continue } else { return }
		}
	}
}

proc about {} {
	set msg1 "ITR ASCII DAT <--> AutoCAD DXF konverter"
	set msg2 "V1.1 2008"
	set msg3 "GNU GPL liszensz"
	if {[catch {winfo exists .}]} {
		puts $msg1
		puts $msg2
		puts $msg3
	} else {
		toplevel .about -class Dialog
		wm title .about "Nevjegy"
		wm resizable .about 0 0
		wm transient .about .
		label .about.msg1 -text $msg1
		label .about.msg2 -text $msg2
		label .about.msg3 -text $msg3
		pack .about.msg1 .about.msg2 .about.msg3
	}
}

global argv
global fileTypes
set fileTypes {
	{"ITR ASCII DAT" {.dat}}
	{"AutoCAD DXF" {.dxf}}
	{"Minden fjl" {.*}}
}
catch {
	wm title . "ITR <--> DXF"
	wm resizable . 0 0 
	wm protocol . WM_DELETE_WINDOW "exit"
	wm protocol . WM_SAVE_YOURSELF "exit"
	menu .menu -relief raised -tearoff 0
	.menu add cascade -label "Parancs" -menu .menu.file
	menu .menu.file -relief raised -tearoff 0
	.menu.file add command -label "Konvertl ..." \
		-command "conv" -accelerator "Ctrl-K"
	.menu.file add command -label "Kilp" \
		-command "destroy ." -accelerator "Ctrl-X"

	.menu add cascade -label "Sugo" -menu .menu.help
	menu .menu.help -relief raised -tearoff 0
	.menu.help add command -label "Nevjegy ..." \
		-command "about"
	. configure -menu .menu
	
	frame .l
	frame .r
	pack .l .r -side left -fill both
	image create photo f1 -file "tcl.gif"
	label .l.logo -image f1 -relief sunken -borderwidth 2
	pack .l.logo
	label .r.c1 -text "Nyiltforrs konverter"
	label .r.c2 -text "GNU GPL licenc"
	label .r.c3 -text "(c) dr. Siki Zoltn"
	label .r.c4 -text "siki.zoltan@chello.hu"
	pack .r.c1 .r.c2 .r.c3 .r.c4
	update
}

global logOK
set logOK 0

if {[llength $argv]} {
	foreach a $argv {
		if {$a == "-h" || $a == "--help"} {
			about
			break
		} else {
			if {[regexp "\.\[dD\]\[aA\]\[tT\]$" $a]} {
				itr2dxf $a
			} elseif {[regexp "\.\[dD\]\[xX\]\[fF\]$" $a]} {
				dxf2itr $a
			}
		}
	}
} else {
	if {[catch {winfo exists .}]} { about }
}
